"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DomainEventPublisher = void 0;
class DomainEventPublisher {
    constructor() { }
    static instance() {
        return new DomainEventPublisher();
    }
    removeSubscriber(subscriber) {
        DomainEventPublisher._subscribers =
            DomainEventPublisher._subscribers.filter((_subscriber) => _subscriber === subscriber);
    }
    subscribe(subscriber) {
        if (!DomainEventPublisher._subscribers)
            DomainEventPublisher._subscribers = [];
        DomainEventPublisher._subscribers.push(subscriber);
    }
    publish(event) {
        DomainEventPublisher._subscribers.forEach((subscriber) => {
            subscriber.handleEvent(event);
        });
    }
    publishAll(aggregate) {
        const events = aggregate.publishEvents();
        events.forEach((event) => this.publish(event));
    }
}
exports.DomainEventPublisher = DomainEventPublisher;
