import { AnyDomainEvent } from "../../core/domain-event.base";
import { MaybePromise } from "../../types/maybe-promise";
import { Type } from "../../types/type";
import { IDomainEventSubscriber } from "./interfaces/domain-event-subscriber.interface";
export type DomainEventHandler<E extends AnyDomainEvent> = (event: E) => MaybePromise<void>;
export declare abstract class DomainEventSubscriber<E extends AnyDomainEvent = AnyDomainEvent> implements IDomainEventSubscriber {
    readonly subscribedEventName: string;
    constructor(subscribedEventName: string);
    abstract handle(event: E): MaybePromise<void>;
    handleEvent(event: E): void;
}
export type AnyDomainEventSubscriber = DomainEventSubscriber;
export type TypeDomainEventSubscriber<T extends AnyDomainEvent = AnyDomainEvent> = Type<DomainEventSubscriber<T>>;
