import { Type } from "../types/type";
import { AnyDomainEvent } from "./domain-event.base";
import { EntityBase, GetEntityProps } from "./entity.base";
export declare abstract class AggregateBase<P> extends EntityBase<P> {
    protected _originalVersion: number;
    protected _events: AnyDomainEvent[];
    protected _loaded: boolean;
    constructor(id: string, props: P, originalVersion: number, loaded: boolean);
    static isAggregate(obj: any): obj is AnyAggregate;
    hasUnpublishedEvents(): boolean;
    publishEvents(): AnyDomainEvent[];
    protected recordEvent(event: AnyDomainEvent): void;
    clearEvents(): void;
    isNew(): boolean;
    get unpublishedEvents(): AnyDomainEvent[];
    get originalVersion(): number;
    get version(): number;
    get loaded(): boolean;
}
export type AnyAggregate = AggregateBase<any>;
export type TypeAggregate<T extends AnyAggregate = AnyAggregate> = Type<T>;
export type AggregateConstructor<T extends AnyAggregate = AnyAggregate> = new (...args: ConstructorParameters<typeof AggregateBase<GetEntityProps<T>>>) => T;
